> For the complete documentation index, see [llms.txt](https://docs.filemail.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.filemail.com/api/sending-files.md).

# Sending files

This is the typical flow on how you would send files using the Filemail API:

{% stepper %}
{% step %}

### Call Initialize

You [Initialize](/api/sending-files/initialize.md) the transfer with all meta data so you get the information you need in order to start uploading the files.&#x20;
{% endstep %}

{% step %}

### Add files/folders to the Transfer

The call to Initialize will return URL and credentials which you will use to upload actual files. You can find more information about this process on the [Upload files](/api/sending-files/upload-files.md) page.
{% endstep %}

{% step %}

### Finalize the Transfer by calling Complete

When all files has finished uploading, you activate the transfer by calling [Complete](/api/sending-files/complete.md).
{% endstep %}
{% endstepper %}

The specification for each step and how to do this is described in the sub pages. Remember to first read the section about [Custom authentication](/custom-authentication.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.filemail.com/api/sending-files.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
